/*
 *  Copyright (c) 2016 Samsung Electronics Co., Ltd All Rights Reserved
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License
 *
 *
 * @file        crypto_service.h
 * @author      Dongsun Lee (ds73.lee@samsung.com)
 * @version     1.0
 * @brief       provides encryption and decription operations.
 */
#ifndef __WAE_CRYPTO_SERVICE_H
#define __WAE_CRYPTO_SERVICE_H

#ifdef __cplusplus
extern "C" {
#endif

#include "types.h"

int encrypt_app_dek(const raw_buffer_s *pubkey, const raw_buffer_s *dek,
					raw_buffer_s **pencrypted_dek);
int decrypt_app_dek(const raw_buffer_s *prikey, const char *prikey_pass,
					const raw_buffer_s *encrypted_dek, raw_buffer_s **pdek);


int encrypt_aes_cbc(const crypto_element_s *ce, const raw_buffer_s *data,
					raw_buffer_s **pencrypted_data);
int decrypt_aes_cbc(const crypto_element_s *ce, const raw_buffer_s *encrypted_data,
					raw_buffer_s **pdata);

#ifdef __cplusplus
}
#endif

#endif /* __WAE_CRYPTO_SERVICE_H */
